﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Timers;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Diagnostics;
using System.Collections;
using System.Windows.Forms;
using Inf;
using RegEdit;

namespace ClientUpdRequest
{
    class Program
    {
        static int n = 0; //Счетчик.
        private static string mac, ipadr, compname, sysname, ram, processor, hdd, opticaldrive, videocontroller, software, netcontroller; //Информация о ПК
        private static IPAddress ip; //Адрес сервера
        private static Queue full_inf;
        static string InfFile;
        public static int full_inf_count;
        private static int port = 1330;
        private static int k = 0;
        private static TcpClient client;
        private static System.Timers.Timer tmr;

        static void Main(string[] args)
        {
            SetRead();
            IPAddress localhost = IPAddress.Parse(ipadr);
            System.Net.Sockets.TcpListener listener = new System.Net.Sockets.TcpListener(localhost, 1330);
            listener.Start();

            full_inf = new Queue();

            while (true)
            {
                k = 0;
                n = 0;
                TcpClient listn = listener.AcceptTcpClient();
                Thread thread = new Thread(new ParameterizedThreadStart(HandleClientThread));
                thread.Start(listn);
            }
        }

        //------------Обновление информации о ПК-----------
        private static void InfUpdate()
        {
            mac = HardwareInf.MacAddress(netcontroller);
            ipadr = HardwareInf.IPAddress(netcontroller);
            compname = CompInf.CompName();
            sysname = CompInf.SysName();
            ram = HardwareInf.RAM().ToString() + "Mb";
            processor = HardwareInf.Processor();
            hdd = HardwareInf.HDD();
            opticaldrive = HardwareInf.OpticalDrive();
            videocontroller = HardwareInf.VideoController();
            software = ForRegEdit.Getinstalledsoftware();
            full_inf.Clear();
            QueueUpd();
            FileServUpd();
            mac = null;
            ipadr = null;
            compname = null;
            sysname = null;
            ram = null;
            processor = null;
            hdd = null;
            opticaldrive = null;
            videocontroller = null;
            software = null;
        }
        //---------------------------------------------------


        private static void FileServUpd()
        {
            string location = Application.StartupPath + @"\inf.ini";
            StreamWriter infwrite = new StreamWriter(location, false, System.Text.Encoding.Unicode);
            InfFile = "";
            InfFile += "CompName|" + compname + Environment.NewLine;
            InfFile += "SysName|" + sysname + Environment.NewLine;
            InfFile += "RAM|" + ram + Environment.NewLine;
            InfFile += "Processor|" + processor + Environment.NewLine;
            for (int i = 0; i < hdd.Split('\n').Length - 1; i++)
                InfFile += "HDD|" + hdd.Split('\n')[i].Trim() + Environment.NewLine;
            for (int i = 0; i < videocontroller.Split('\n').Length - 1; i++)
                InfFile += "VideoController|" + videocontroller.Split('\n')[i].Trim() + Environment.NewLine;
            for (int i = 0; i < opticaldrive.Split('\n').Length - 1; i++)
                InfFile += "OpticalDrive|" + opticaldrive.Split('\n')[i].Trim() + Environment.NewLine;
            for (int i = 0; i < software.Split('\n').Length - 1; i++)
                InfFile += "Software|" + software.Split('\n')[i].Trim() + Environment.NewLine;

            if (File.Exists(location))
            {
                infwrite.Write(InfFile);
            }
            else
            {
                File.Create(location);
                infwrite.Write(InfFile);
            }

            infwrite.Close();
        }

        //--Заполение очереди--
        private static void QueueUpd()
        {
            full_inf.Enqueue("Mac-Address|" + mac);
            full_inf.Enqueue("IP-Address|" + ipadr.Trim());
            full_inf.Enqueue("CompName|" + compname);
            full_inf.Enqueue("SysName|" + sysname);
            full_inf.Enqueue("RAM|" + ram);
            full_inf.Enqueue("Processor|" + processor);
            for (int i = 0; i < hdd.Split('\n').Length - 1; i++)
                full_inf.Enqueue("HDD|" + hdd.Split('\n')[i]);
            for (int i = 0; i < videocontroller.Split('\n').Length - 1; i++)
                full_inf.Enqueue("VideoController|" + videocontroller.Split('\n')[i]);
            for (int i = 0; i < opticaldrive.Split('\n').Length - 1; i++)
                full_inf.Enqueue("OpticalDrive|" + opticaldrive.Split('\n')[i]);
            for (int i = 0; i < software.Split('\n').Length - 1; i++)
                full_inf.Enqueue("Software|" + software.Split('\n')[i]);
            full_inf_count = full_inf.Count;
        }
        //-------------------

        private static void SetRead()
        {
            string location = Application.StartupPath + @"\set.ini";
            netcontroller = null;
            StreamReader setread = new StreamReader(location, System.Text.Encoding.Unicode);
            string SetFile = setread.ReadToEnd();
            for (int i = 0; i < SetFile.Split('\n').Length; i++)
            {
                if (SetFile.Split('\n')[i].Split('|')[0] == "NetworkAdapter")
                    netcontroller += SetFile.Split('\n')[i].Split('|')[1].Trim();

                if (SetFile.Split('\n')[i].Split('|')[0] == "Mac-Address")
                    mac += SetFile.Split('\n')[i].Split('|')[1].Trim();

                if (SetFile.Split('\n')[i].Split('|')[0] == "IP-Address")
                    ipadr += SetFile.Split('\n')[i].Split('|')[1].Trim();

                if (SetFile.Split('\n')[i].Split('|')[0] == "IP-Server")
                {
                    ip = IPAddress.Parse(SetFile.Split('\n')[i].Split('|')[1].Trim());
                }
            }
            setread.Close();
        }


        private static string ReadResponse(TcpClient client)
        {
            byte[] buffer = new byte[256];
            int totalRead = 0;
            do
            {
                int read = client.GetStream().Read(buffer, totalRead,
                    buffer.Length - totalRead);
                totalRead += read;
            } while (client.GetStream().DataAvailable);
            return Encoding.Unicode.GetString(buffer, 0, totalRead);
        }

        private static void SendMessage(TcpClient client, string message)
        {
            byte[] bytes = Encoding.Unicode.GetBytes(message);
            client.GetStream().Write(bytes, 0, bytes.Length);
        }

        private static string ReadMessage(TcpClient client)
        {
            byte[] buffer = new byte[256];
            int totalRead = 0;
            do
            {
                int read = client.GetStream().Read(buffer, totalRead, buffer.Length - totalRead);
                totalRead += read;
            } while (client.GetStream().DataAvailable);

            return Encoding.Unicode.GetString(buffer, 0, totalRead);
        }

        static void HandleClientThread(object obj)
        {
            TcpClient client = obj as TcpClient;

            bool done = false;
            while (!done)
            {
                string received = ReadMessage(client);
                done = false;
                if (received.Equals("Update"))
                {
                    InfUpdate();
                    client = new TcpClient(ip.ToString(), port);
                    SendMessage(client, "1");
                 //   tmr.Start();

                    while (n != full_inf_count+1)
                    {

                        if (ReadResponse(client) == "OK" && k < full_inf_count)
                        {
                            string message = full_inf.Dequeue().ToString();
                            SendMessage(client, message);
                            k++;
                        }
                        else
                        {
                            SendMessage(client, "bye");
                            done = true;
                            k = 0;
                        }
                        Thread.Sleep(100);
                        n++;
                    }
                    full_inf.Clear();
                }

            }
            client.Close();
        }
    }
}
